
Friend Class Form1
    Inherits System.Windows.Forms.Form

    Private DEV As Devices = New Devices()
    Friend SelectedDeviceName As String

    Private Sub Form_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        EventsAreEnabled = False
        Me.Text = AppTitleAndVersion()
        Load_INI()

        Refresh()
        Opacity = 1
        ReadDevices()
        SelectDevice()
        EventsAreEnabled = True

    End Sub

    Private Sub Form_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        CloseProgram()
    End Sub

    Private Sub CloseProgram()
        DEV.CutLooseHardwareNotifications(Me.Handle)
        DEV = Nothing
        Save_INI()
        End
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub

    Private Sub ReadDevices()
        Dim HardwareList As String() = DEV.GetAll()
        For Each s As String In HardwareList
            ListBox1.Items.Add(s)
        Next
        DEV.HookHardwareNotifications(Me.Handle, True)
    End Sub

    Friend Sub SelectDevice()
        ListBox1.SelectedIndex = ListBox1.FindString(SelectedDeviceName)
    End Sub

    Private Sub ListBox1_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListBox1.SelectedIndexChanged
        If Not EventsAreEnabled Then Exit Sub
        If ListBox1.SelectedItem IsNot Nothing Then
            SelectedDeviceName = ListBox1.SelectedItem.ToString()
        Else
            SelectedDeviceName = ""
        End If
        Save_INI()
    End Sub

    Protected Overrides Sub WndProc(ByRef m As Message)
        Select Case m.Msg
            Case WM_DEVICECHANGE
                If True Then
                    If m.WParam.ToInt32() = DBT_DEVNODES_CHANGED Then
                        ListBox1.Items.Clear()
                        For Each s As String In DEV.GetAll()
                            ListBox1.Items.Add(s)
                        Next
                        SelectDevice()
                    End If
                    Exit Select
                End If
        End Select
        MyBase.WndProc(m)
    End Sub

    Private Sub EnableDevice_Click(ByVal sender As Object, ByVal e As EventArgs) Handles Button_EnableDevice.Click
        DEV.CutLooseHardwareNotifications(Me.Handle)
        DEV.SetDeviceState(SelectedDeviceName, True)
        DEV.HookHardwareNotifications(Me.Handle, True)
    End Sub

    Private Sub DisableDevice_Click(ByVal sender As Object, ByVal e As EventArgs) Handles Button_DisableDevice.Click
        DEV.CutLooseHardwareNotifications(Me.Handle)
        DEV.SetDeviceState(SelectedDeviceName, False)
        DEV.HookHardwareNotifications(Me.Handle, True)
    End Sub

End Class