Imports System.Collections.Generic
Imports System.Text
Imports System.Runtime.InteropServices

Friend Module DevApi

    <DllImport("user32.dll", CharSet:=CharSet.Auto)> _
    Friend Function RegisterDeviceNotification(ByVal hRecipient As IntPtr, ByVal NotificationFilter As DEV_BROADCAST_DEVICEINTERFACE, ByVal Flags As UInt32) As IntPtr
    End Function

    <DllImport("user32.dll", CharSet:=CharSet.Auto)> _
    Friend Function UnregisterDeviceNotification(ByVal hHandle As IntPtr) As UInteger
    End Function

    <DllImport("setupapi.dll", SetLastError:=True)> _
    Friend Function SetupDiGetClassDevs(ByRef gClass As Guid, ByVal iEnumerator As UInt32, ByVal hParent As IntPtr, ByVal nFlags As UInt32) As IntPtr
    End Function

    <DllImport("setupapi.dll", SetLastError:=True)> _
    Friend Function SetupDiDestroyDeviceInfoList(ByVal lpInfoSet As IntPtr) As Integer
    End Function

    <DllImport("setupapi.dll", SetLastError:=True)> _
    Friend Function SetupDiEnumDeviceInfo(ByVal lpInfoSet As IntPtr, ByVal dwIndex As UInt32, ByVal devInfoData As SP_DEVINFO_DATA) As Boolean
    End Function

    <DllImport("setupapi.dll", SetLastError:=True)> _
    Friend Function SetupDiGetDeviceRegistryProperty(ByVal lpInfoSet As IntPtr, ByVal DeviceInfoData As SP_DEVINFO_DATA, ByVal [Property] As UInt32, ByVal PropertyRegDataType As UInt32, ByVal PropertyBuffer As StringBuilder, ByVal PropertyBufferSize As UInt32, _
     ByVal RequiredSize As IntPtr) As Boolean
    End Function

    <DllImport("setupapi.dll", SetLastError:=True, CharSet:=CharSet.Auto)> _
    Friend Function SetupDiSetClassInstallParams(ByVal DeviceInfoSet As IntPtr, ByVal DeviceInfoData As IntPtr, ByVal ClassInstallParams As IntPtr, ByVal ClassInstallParamsSize As Integer) As Boolean
    End Function

    <DllImport("setupapi.dll", CharSet:=CharSet.Auto)> _
    Friend Function SetupDiCallClassInstaller(ByVal InstallFunction As UInt32, ByVal DeviceInfoSet As IntPtr, ByVal DeviceInfoData As IntPtr) As [Boolean]
    End Function

    <StructLayout(LayoutKind.Sequential)> _
    Friend Structure DEV_BROADCAST_HANDLE
        Friend dbch_size As Integer
        Friend dbch_devicetype As Integer
        Friend dbch_reserved As Integer
        Friend dbch_handle As IntPtr
        Friend dbch_hdevnotify As IntPtr
        Friend dbch_eventguid As Guid
        Friend dbch_nameoffset As Long
        Friend dbch_data As Byte
        Friend dbch_data1 As Byte
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Friend Class DEV_BROADCAST_DEVICEINTERFACE
        Friend dbcc_size As Integer
        Friend dbcc_devicetype As Integer
        Friend dbcc_reserved As Integer
    End Class

    <StructLayout(LayoutKind.Sequential)> _
    Friend Class SP_DEVINFO_DATA
        Friend cbSize As Integer
        Friend classGuid As Guid
        Friend devInst As Integer
        Friend reserved As ULong
    End Class

    <StructLayout(LayoutKind.Sequential)> _
    Friend Class SP_DEVINSTALL_PARAMS
        Friend cbSize As Integer
        Friend Flags As Integer
        Friend FlagsEx As Integer
        Friend hwndParent As IntPtr
        Friend InstallMsgHandler As IntPtr
        Friend InstallMsgHandlerContext As IntPtr
        Friend FileQueue As IntPtr
        Friend ClassInstallReserved As IntPtr
        Friend Reserved As Integer
        <MarshalAs(UnmanagedType.LPTStr)> _
        Friend DriverPath As String
    End Class

    <StructLayout(LayoutKind.Sequential)> _
    Friend Class SP_PROPCHANGE_PARAMS
        Friend ClassInstallHeader As New SP_CLASSINSTALL_HEADER()
        Friend StateChange As Integer
        Friend Scope As Integer
        Friend HwProfile As Integer
    End Class

    <StructLayout(LayoutKind.Sequential)> _
    Friend Class SP_CLASSINSTALL_HEADER
        Friend cbSize As Integer
        Friend InstallFunction As Integer
    End Class

    Friend Const DIGCF_ALLCLASSES As Integer = (&H4)
    Friend Const DIGCF_PRESENT As Integer = (&H2)
    Friend Const INVALID_HANDLE_VALUE As Integer = -1
    Friend Const SPDRP_DEVICEDESC As Integer = (&H0)
    Friend Const MAX_DEV_LEN As Integer = 1000
    Friend Const DEVICE_NOTIFY_WINDOW_HANDLE As Integer = (&H0)
    Friend Const DEVICE_NOTIFY_SERVICE_HANDLE As Integer = (&H1)
    Friend Const DEVICE_NOTIFY_ALL_INTERFACE_CLASSES As Integer = (&H4)
    Friend Const DBT_DEVTYP_DEVICEINTERFACE As Integer = (&H5)
    Friend Const DBT_DEVNODES_CHANGED As Integer = (&H7)
    Friend Const WM_DEVICECHANGE As Integer = (&H219)
    Friend Const DIF_PROPERTYCHANGE As Integer = (&H12)
    Friend Const DICS_FLAG_GLOBAL As Integer = (&H1)
    Friend Const DICS_FLAG_CONFIGSPECIFIC As Integer = (&H2)
    Friend Const DICS_ENABLE As Integer = (&H1)
    Friend Const DICS_DISABLE As Integer = (&H2)

End Module


Friend Class Devices

    Friend Function GetAll() As String()
        Dim HWList As New List(Of String)()
        Try
            Dim myGUID As Guid = System.Guid.Empty
            Dim hDevInfo As IntPtr
            hDevInfo = SetupDiGetClassDevs(myGUID, _
                                            0, _
                                            IntPtr.Zero, _
                                            DIGCF_ALLCLASSES Or _
                                            DIGCF_PRESENT)
            If hDevInfo.ToInt32() = INVALID_HANDLE_VALUE Then
                Return HWList.ToArray()
            End If
            Dim DeviceInfoData As SP_DEVINFO_DATA
            DeviceInfoData = New SP_DEVINFO_DATA()
            DeviceInfoData.cbSize = 28
            DeviceInfoData.devInst = 0
            DeviceInfoData.classGuid = System.Guid.Empty
            DeviceInfoData.reserved = 0
            Dim i As UInt32 = 0
            Dim DeviceName As New StringBuilder("")
            DeviceName.Capacity = MAX_DEV_LEN
            While SetupDiEnumDeviceInfo(hDevInfo, i, DeviceInfoData)
                DeviceName.Length = 0
                SetupDiGetDeviceRegistryProperty(hDevInfo, _
                                                 DeviceInfoData, _
                                                 SPDRP_DEVICEDESC, _
                                                 0, _
                                                 DeviceName, _
                                                 MAX_DEV_LEN, _
                                                 IntPtr.Zero)
                If DeviceName.Length = 0 Then
                    HWList.Add(">>> ERROR: Device name not found")
                Else
                    HWList.Add(DeviceInfoData.devInst.ToString + _
                               " " + _
                               DeviceName.ToString())
                End If
                i += 1UI
            End While
            SetupDiDestroyDeviceInfoList(hDevInfo)
        Catch ex As Exception
            MsgBox("Failed to enumerate device tree." & vbCrLf & ex.ToString, MsgBoxStyle.Information)
        End Try
        Return HWList.ToArray()
    End Function

    Friend Sub SetDeviceState(ByVal device As String, ByVal bEnable As Boolean)
        If Not IsAdministrator() Then
            If Not CallUserPermission() Then
                Return
            End If
        End If

        If device.StartsWith(">>> ERROR") Then Return
        Try
            Dim myGUID As Guid = System.Guid.Empty
            Dim hDevInfo As IntPtr = SetupDiGetClassDevs(myGUID, 0, IntPtr.Zero, DIGCF_ALLCLASSES Or DIGCF_PRESENT)
            If hDevInfo.ToInt32() = INVALID_HANDLE_VALUE Then Return
            Dim DeviceInfoData As SP_DEVINFO_DATA
            DeviceInfoData = New SP_DEVINFO_DATA()
            DeviceInfoData.cbSize = 28
            DeviceInfoData.devInst = 0
            DeviceInfoData.classGuid = System.Guid.Empty
            DeviceInfoData.reserved = 0
            Dim i As UInt32 = 0
            Dim DeviceName As New StringBuilder("")
            DeviceName.Capacity = MAX_DEV_LEN
            While SetupDiEnumDeviceInfo(hDevInfo, i, DeviceInfoData)
                DeviceName.Length = 0
                SetupDiGetDeviceRegistryProperty(hDevInfo, _
                                                 DeviceInfoData, _
                                                 SPDRP_DEVICEDESC, _
                                                 0, _
                                                 DeviceName, _
                                                 MAX_DEV_LEN, _
                                                 IntPtr.Zero)
                If device = DeviceInfoData.devInst.ToString + _
                            " " + _
                            DeviceName.ToString() Then
                    ChangeIt(hDevInfo, DeviceInfoData, bEnable)
                End If
                i += 1UI
            End While
            SetupDiDestroyDeviceInfoList(hDevInfo)
        Catch ex As Exception
            MsgBox("Failed to enumerate device tree." & vbCrLf & ex.ToString, MsgBoxStyle.Information)
        End Try
    End Sub

    Friend Sub HookHardwareNotifications(ByVal callback As IntPtr, ByVal UseWindowHandle As Boolean)
        Dim dbdi As New DEV_BROADCAST_DEVICEINTERFACE()
        dbdi.dbcc_size = Marshal.SizeOf(dbdi)
        dbdi.dbcc_reserved = 0
        dbdi.dbcc_devicetype = DBT_DEVTYP_DEVICEINTERFACE
        If UseWindowHandle Then
            RegisterDeviceNotification(callback, _
                                       dbdi, _
                                       DEVICE_NOTIFY_ALL_INTERFACE_CLASSES Or _
                                       DEVICE_NOTIFY_WINDOW_HANDLE)
        Else
            RegisterDeviceNotification(callback, _
                                       dbdi, _
                                       DEVICE_NOTIFY_ALL_INTERFACE_CLASSES Or _
                                       DEVICE_NOTIFY_SERVICE_HANDLE)
        End If
    End Sub

    Friend Sub CutLooseHardwareNotifications(ByVal callback As IntPtr)
        UnregisterDeviceNotification(callback)
    End Sub

    Private Sub ChangeIt(ByVal hDevInfo As IntPtr, ByVal devInfoData As SP_DEVINFO_DATA, ByVal bEnable As Boolean)
        Try
            Dim szOfPcp As Integer
            Dim ptrToPcp As IntPtr
            Dim szDevInfoData As Integer
            Dim ptrToDevInfoData As IntPtr

            Dim pcp As New SP_PROPCHANGE_PARAMS()
            If bEnable Then
                pcp.ClassInstallHeader.cbSize = Marshal.SizeOf(GetType(SP_CLASSINSTALL_HEADER))
                pcp.ClassInstallHeader.InstallFunction = DIF_PROPERTYCHANGE
                pcp.StateChange = DICS_ENABLE
                pcp.Scope = DICS_FLAG_GLOBAL
                pcp.HwProfile = 0
                ' --------------------------------------------------------- marshalled params
                szOfPcp = Marshal.SizeOf(pcp)
                ptrToPcp = Marshal.AllocHGlobal(szOfPcp)
                Marshal.StructureToPtr(pcp, ptrToPcp, True)
                szDevInfoData = Marshal.SizeOf(devInfoData)
                ptrToDevInfoData = Marshal.AllocHGlobal(szDevInfoData)
                ' ---------------------------------------------------------
                If SetupDiSetClassInstallParams(hDevInfo, _
                                                ptrToDevInfoData, _
                                                ptrToPcp, _
                                                Marshal.SizeOf(GetType(SP_PROPCHANGE_PARAMS))) Then
                    SetupDiCallClassInstaller(DIF_PROPERTYCHANGE, hDevInfo, ptrToDevInfoData)
                End If
                pcp.ClassInstallHeader.cbSize = Marshal.SizeOf(GetType(SP_CLASSINSTALL_HEADER))
                pcp.ClassInstallHeader.InstallFunction = DIF_PROPERTYCHANGE
                pcp.StateChange = DICS_ENABLE
                pcp.Scope = DICS_FLAG_CONFIGSPECIFIC
                pcp.HwProfile = 0
            Else
                pcp.ClassInstallHeader.cbSize = Marshal.SizeOf(GetType(SP_CLASSINSTALL_HEADER))
                pcp.ClassInstallHeader.InstallFunction = DIF_PROPERTYCHANGE
                pcp.StateChange = DICS_DISABLE
                pcp.Scope = DICS_FLAG_CONFIGSPECIFIC
                pcp.HwProfile = 0
            End If
            ' ------------------------------------------------------- marshalled params
            szOfPcp = Marshal.SizeOf(pcp)
            ptrToPcp = Marshal.AllocHGlobal(szOfPcp)
            Marshal.StructureToPtr(pcp, ptrToPcp, True)
            szDevInfoData = Marshal.SizeOf(devInfoData)
            ptrToDevInfoData = Marshal.AllocHGlobal(szDevInfoData)
            Marshal.StructureToPtr(devInfoData, ptrToDevInfoData, True)
            ' ---------------------------------------------------------
            Dim rslt1 As Boolean = SetupDiSetClassInstallParams(hDevInfo, _
                                                                ptrToDevInfoData, _
                                                                ptrToPcp, _
                                                                Marshal.SizeOf(GetType(SP_PROPCHANGE_PARAMS)))
            Dim rstl2 As Boolean = SetupDiCallClassInstaller(DIF_PROPERTYCHANGE, _
                                                             hDevInfo, _
                                                             ptrToDevInfoData)
        Catch
        End Try
    End Sub


    Friend Function CallUserPermission() As Boolean
        If MsgBox("Unable to change device state." & _
                  vbCrLf & "Restart with administrator privileges?", _
                  MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
            RestartAsAdministrator()
            Return True
        Else
            Return False
        End If
    End Function

    Friend Function IsAdministrator() As Boolean
        Return New Security.Principal.WindowsPrincipal( _
                   Security.Principal.WindowsIdentity.GetCurrent).IsInRole( _
                   Security.Principal.WindowsBuiltInRole.Administrator)
    End Function

    Friend Sub RestartAsAdministrator()
        Dim exeName As String = System.Diagnostics.Process.GetCurrentProcess.MainModule.FileName
        Dim startInfo As ProcessStartInfo = New ProcessStartInfo(exeName)
        startInfo.Verb = "runas"
        System.Diagnostics.Process.Start(startInfo)
        'Application.Current.Shutdown()
        Application.Exit()
    End Sub

End Class
